#!/client/bin/perl
use strict;

my $t = `cat test.tmpl`;


#$t = "@>$t<@";
print STDERR "Text: '$t'\n";

my $delim_pats = 1; # Flag
my ($t_open, $t_close) = ('<@', '@>');

my $state = 'TEXT';
my $DELIM = "(?:(?:\Q$t_open\E)|(?:\Q$t_close\E))";

print STDERR "DELIM: '$DELIM'\n";

my @tokens = split /($DELIM|\n)/, $t;



if (0)
{
    foreach my $tok (@tokens)
    {
	print STDERR "t '$tok'\n";
    }
}


my $ERROR;


my $depth = 0;
my $lineno = 1;
my @content;
my $cur_item = '';
my $prog_start;
while (@tokens)
{
    my $t = shift @tokens;
    next if $t eq '';
    if ($t eq $t_open) {        # Brace or other opening delimiter
	if ($depth == 0) {
	    push @content, [$state, $cur_item, $lineno] if $cur_item ne '';
	    $cur_item = '';
	    $state = 'PROG';
	    $prog_start = $lineno;
	} else {
	    $cur_item .= $t;
	}
	$depth++;
    } elsif ($t eq $t_close) {  # Brace or other closing delimiter
	$depth--;
	if ($depth < 0) {
	    $ERROR = "Unmatched close brace at line $lineno";
	    return undef;
	} elsif ($depth == 0) {
	    push @content, [$state, $cur_item, $prog_start] if $cur_item ne '';
	    $state = 'TEXT';
	    $cur_item = '';
	} else {
	    $cur_item .= $t;
	}
    } elsif (!$delim_pats && $t eq '\\\\') { # precedes \\\..\\\{ or \\\..\\\}
	$cur_item .= '\\';
    } elsif (!$delim_pats && $t =~ /^\\([{}])$/) { # Escaped (literal) brace?
        $cur_item .= $1;
    } elsif ($t eq "\n") {      # Newline
	$lineno++;
	$cur_item .= $t;
    } else {                    # Anything else
	$cur_item .= $t;
    }
}

if ($state eq 'PROG')
{
    $ERROR = "End of data inside program text that began at line $prog_start";
    return undef;
}
elsif ($state eq 'TEXT')
{
    push @content, [$state, $cur_item, $lineno] if $cur_item ne '';
}
else
{
    die("Can't happen error \#1");
}


my $prog;
foreach my $c (@content)
{
    my ($state,$item,$lin) = @$c;

    if ($state eq "PROG")
    {
	$prog .= $item;
    }
    elsif ($state eq "TEXT")
    {

	my $s = $item;

	$s =~ s/\\/\\\\/g;
	$s =~ s/\'/\\\'/g;

	$prog .= ";\$OUT .= '$s';";
    }
#    print "s $state, line $lin, t '$item'\n";
}


#print "----------------------\n";
print "$prog";



my $OUT;

eval "$prog";

if (my $err = $@)
{
    print "ERR: $err\n";
}

print "-------------\n";
print "-------------\n";
print "-------------\n";

print "OUT: '$OUT'\n";







