#
# $Id: Config.pm,v 1.11 2006/09/04 05:44:13 bb Exp $
#
# Copyright (C) 2000, 2001 Rodney Volz
#
# Generische Konfiguration fuer ein db_ph Setup
#

package PHTML::Config;

use PHTML::Session;

use Storable;
use strict;

sub new
{
  my ($this) = @_;
  my $class = ref ($this) || $this; # class or object
  my $self = {};

  bless ($self, $class);

  $self->init;

  return($self);
}


# To be overloaded by child classes
sub init
{
    print STDERR "PHTML::Config init\n";
}



sub q
{
    my ($self) = @_;
    
    return($self->{q});
}



# Take an incoming request and return a scalar session ID
sub request
{
    my ($self,$q) = @_;

    $self->{q} = $q; # Remember http Request

#    print STDERR "$$ Config.pm: got request $q\n"; # DEBUG

    my $SID;

    $SID = $q->param("S") if ($q); # Get SID, if given.
#    undef($SID) unless ($SID);

    # Session file
    my $sfile = $self->sfile($SID);




    # Session ggfs. einlesen (per 'Storable' Module)
    if (defined($SID) && -f $sfile)
    {
#	print STDERR "$$ want SID $SID retrieve as $sfile\n"; # DEBUG

	my $hashref = retrieve($sfile);
	$self->{S} = $hashref;


	if (!$hashref)
	{
	    print STDERR "$$ sid $SID retrieve failed\n";
	}
    }
    else
    {
	print STDERR "$$ Commencing empty sid.\n";
	$self->{S} = new PHTML::Session;
    } # endif


#    $SID = "S$$" . "_" . (time()) . "_" . $self->{sidseq}++;

    $main::sidcnt = time() unless ($main::sidcnt);

    $SID = "S$$" . "_" . ($main::sidcnt++) . "_" . $self->{sidseq}++;



    $self->{sid} = $SID;

    return($self->{sid});
} # request()



sub session
{
    my ($self) = @_;

    return($self->{S});
}

sub redirect
{
    my ($self,$url) = @_;

    if (defined($url))
    {
	$self->{redirect} = $url;
	die("__p_redirect_magic9928374");
    }

    return($self->{redirect});
}


# Stop further template file processing, but return without an error.
sub break
{
    my ($self) = @_;

    die("__p_break_magic23498228");
}



sub setHeader
{
    my ($self,$header) = @_;
    $header =~ s/[\r\n]+$//g; # Strip trailing returns
    $self->{header} = $header;
}

sub getHeader
{
    my ($self,$header) = @_;
    return($self->{header});
}


sub error
{
    my ($self,$err) = @_;

    # Falls Argument uebergeben wurde, Fehler-Variable setzen
    if (defined($err))
    {
	$self->{error} = $err;
#	print STDERR "error set to: '$err'\n";
    }

    return($self->{error});
}

sub clrerror
{
    my ($self) = @_;

    delete($self->{error});
}


sub ping
{
  my ($self) = @_;

  print "$self PHTML::Config ping\n";
}


sub sfile
{
    my ($self,$sid) = @_;
    my $sfile;
    my $sessdir="/tmp/phtmlsess";
    if (-d $sessdir){
	 $sfile ="$sessdir/S.$sid";
    }else{
  	$sfile = "/tmp/S.$sid";
    }	
    
    return($sfile);
} # sfile()



#
# finish is called after processing the phtml file, but *before*
# closing the FCGI request. Storing of session data containers
# etc. has to happen here, since otherwise the client may
# start the next session in sequence before the session storing
# has finished.
#
#
sub finish
{
    my ($self) = @_;

    my $S = $self->session; # Session data container

    # Save session
    my $sfile = $self->sfile($self->sid);
    store($S,$sfile) || print STDERR "could not store to sfile\n";

    print STDERR "$$ Session " . $self->sid . " stored to $sfile\n";
} # sub finish()


#
# Config::end is called *after* the request to the client is
# finished. Here is a good place for closing db connections etc.
#
sub end
{
    my ($self) = @_;
}


sub sid
{
    my ($self) = @_;

    return($self->{sid});
} # sub sid()

1;
