#
# $Id: ConfigLegacy.pm,v 1.5 2001/08/30 19:09:40 rodney Exp $
#
# Copyright (C) 2000, 2001 Rodney Volz
#
# Generische Konfiguration fuer ein db_ph Setup
#
package PHTML::ConfigLegacy;

use PHTML::SessionLegacy;
use PHTML::Config;
use strict;


our @ISA = qw(PHTML::Config);

sub request
{
    my ($self,$q) = @_;
    
    my $ret = $self->SUPER::request($q);

    # Place $S in the new package namespace.
    {
	no strict 'refs';
	my $n = $self->sid . "::S";
	$$n = $self->session;
    }

    return($ret);
} # request()



sub session
{
    my ($self) = @_;

    my $S = $self->SUPER::session;

    bless($S,"PHTML::SessionLegacy");

    # Do some initialization
    $S->{_C} = $self;

    return($S);
} # session



sub init
{
    die("ConfigLegacy::init must be customized and overloaded!");
}





sub dbh
{
    my ($self) = @_;
    return($self->{dbh});
}



sub finish
{
    my ($self,@args) = @_;

    $Storable::forgive_me = 1; # Magic. See Storable(3).
    $self->SUPER::finish(@args);
} # finish





sub end
{
    my ($self,@args) = @_;



    $self->SUPER::end(@args);

#    sleep(10); # Not in a hurry here.

    eval {
	$self->dbh->rollback;
	$self->dbh->do("rollback");
#	$self->dbh->disconnect;

	print STDERR "$$ dbh connections rolled back successfully\n";
    };
    if (my $err = $@)
    {
	print STDERR "FATAL: rollback failed in ConfigLegacy\n";
	die($err);
    }


    
}



1;

