#
# $Id: Session.pm,v 1.7 2004/12/02 13:31:10 rodney Exp $
#
# Copyright (C) Rodney Volz 2000, 2001
#
package PHTML::Session;
use strict;



sub new {
    my ($this) = @_;
    my $class = ref ($this) || $this; # class or object
    my $self = {};

    bless($self, $class);

    return($self);
}





#
# init($q) is called for each http request.
#
# $q    http Request
#
sub init {
  my ($self,$q) = @_;

  
}




# ----------------------------------------------------------------------

=head2 display_input_errors

C<< <@ $S->display_input_errors (@error); @> >>

Given a list of errors which have occurred during parsing the user
input in the current page. Display them as table rows.

=cut

sub display_input_errors {
  my ($self, @error) = @_;

  my $html = '';

  if (0 < $$self{cnt}++ && @error) {
    $html .= "<tr bgcolor=\"red\">\n";
    $html .= "  <td><font color=\"white\"><b>ERRORs</b></font></td>\n";
    $html .= "  <td>&nbsp;</td>\n";
    $html .= "</tr>\n";

    my $count = 1;

    foreach my $e (@error) {

      $html .= "<tr>\n";
      $html .= "  <td align=\"right\">$count</td>\n";
      $html .= "  <td>$e</td>\n";
      $html .= "</tr>\n";

      ++$count;
    }
  }

  return $html;
}


# ----------------------------------------------------------------------

sub id {
    my ($this,$arg) = @_;
    return($this->{__p_id});
}

sub dbh {
    my ($this,$arg) = @_;

    if (defined($arg))
    {
#	die("out of bounds") unless ($arg < $#this-> ...
	return($this->{__p_dbh}[$arg]);
    }
    else
    {
	return($this->{__p_dbh}[0]);
    }
}



# Return all dbh handles
sub dbhHandles {
    my ($this) = @_;

    return unless defined($this->{__p_dbh}); # No handle defined?

    return(@{$this->{__p_dbh}});
} # dbhHandles()


sub dbhSet {
    my ($this,$n,$arg) = @_;


    $this->{__p_dbh}[$n] = $arg;
}

sub q {
    my ($this,$arg) = @_;
    return($this->{__p_q});
}


# Set the error-template for a .phtml session
sub etmpl {
    my ($this,$arg) = @_;
    $this->{__p_etmpl} = $arg;
}


# Redirect client to another URL
sub Xredirect {
    my ($this,$arg) = @_;


    if ($arg !~ /^http/ &&
	$arg !~ /^ftp/)
    {
      die("redirect URLs must always be absolute");
    }

    $this->{__p_redirect} = $arg;
    die("__p_redirect_magic9928374");
}



# Return error text
sub error {
    my ($this) = @_;

    return($this->{__p_error});
}

sub commit {
    my ($this) = @_;

    $this->dbh->do("commit");
    $this->dbh->commit;
}



sub rollback {
    my ($this) = @_;

    $this->dbh->do("rollback");
    $this->dbh->rollback;
}


# ----------------------------------------------------------------------

=head2 quote

C<< $S->quote ($arg); >>

Wrapper around my database handle's quote () command.

=cut

sub quote {
  my ($self, $f_arg) = @_;

  $self->dbh ()->quote ($f_arg);
}

# ----------------------------------------------------------------------


sub http_enc
{
    my ($this,$s) = @_;
    my $ret;


    my @s = unpack("C*",$s);


#    $ret = join(",",@s);

    for (my $n = 0; $n <= $#s; $n++)
    {
        if ($s[$n] < 50 || $s[$n] > 120)
        {
            $ret .= sprintf("%%%02x",$s[$n]);
#            $ret .= "&#" . sprintf("%d",$s[$n]);
            next;
        }

        $ret .= pack("C",$s[$n]);
    }

    return($ret);
}


sub html_enc
{
    my ($this,$s) = @_;
    my $ret;


    my @s = unpack("C*",$s);


#    $ret = join(",",@s);

    for (my $n = 0; $n <= $#s; $n++)
    {
	my $c = $s[$n];

        if ($c < 0x41 || $c > 0x7a)
        {
#            $ret .= sprintf("%%%02x",$c);
            $ret .= "&#" . sprintf("%d",$c). ";";
            next;
        }

        $ret .= pack("C",$s[$n]);
    }

    return($ret);
}

1;
