#
# $Id: dbrecs.pm,v 1.15 2004/05/27 08:08:26 rodney Exp $
#
# Copyright (C) Rodney Volz 1999, 2000, 2001
#
# Usage:
#
#        @rows = new dbrecs($dbh,"SELECT name, vorname
#                                FROM adressen WHERE id < 5");
#        $row = $rows[0];
#        print "your name is $row->{vorname}.\n";
#

package PHTML::dbrecs;

sub new {
    my ($this,$dbh,$cmd) = @_;
    my $class = ref ($this) || $this; # class or object
    my $self = {};

    bless ($self, $class);

#    $self->init ();

    # leeres Objekt zurueckliefern
    return($self) unless ($dbh && $cmd);


    my @array = $self->initfrom($dbh,$cmd);

    if (!wantarray && $#array > 0)
    {
	die("multiple records found but wantarray missing");
    }

    return (wantarray ? @array : $array[0]);
}




#
# Usage: $adr->initfrom($dbh,$cmd)
#
sub initfrom
{
    my ($self,$dbh,$cmd) = @_;

    my $sth;
    my @arr;
    eval {
	$sth = $dbh->prepare($cmd) || die("prepare failed: " . $dbh->errstr);
	my $rv = $sth->execute || die $dbh->errstr;
#	die("failed") if ($rv != 0);

#	if ($sth->rows != 0)
#	{
#	    print "die...\n";
#	    die("query '$cmd' did not return exactly one row");
#	}



	my @names = @{$sth->{NAME}};
#	print "names: '" . join(", ",@names) . "'\n";


	# Fetch one row
	while (my @values = $sth->fetchrow_array)
	{
	    if ($#names != $#values)
	    {
		print STDERR "dbh->error " . $dbh->errstr . "\n" if ($dbh->errstr);
		print STDERR "dbh->err " . $dbh->err . "\n" if ($dbh->err);
		die("name count $#names doesn't match value count $#values");
	    }


	    my $object = $self->new; # Get empty new row
#	    my $object = {}; # Fuehrt zu Fehlern "can't call method xy on unblessed reference"
	    push(@arr,$object);

	    my $cnt = 0;
	    for (my $n = 0; $n <= $#names; $n++)
	    {
		$object->{lc($names[$n])} = $values[$n];
		$cnt++;
#		print "object->{lc(" . $names[$n] . ")} = " . $values[$n] . "\n";
	    }

	    die("no fields found") unless ($cnt);
	} # while

	$sth->finish;

    };
    if ($@)
    {
	my $err = $@;
	$sth->finish if ($sth);
	print STDERR "FAILED: $err";
	print STDERR "CMD: $cmd\n";
	$err .= " cmd: $cmd" if ($cmd);

	btrace();

	die("ORA-01013 - user requested cancel") if ($err =~ /ORA-01013/);
	die($err);
#	return; # return undef!
    }

    $sth->finish;


    return(@arr);
}



sub dump
{
    my ($self) = @_;

    my %v = %$self;
    my $out;

    foreach my $k (keys %v)
    {
	$out .= "k $k, v $v{$k}\n";
    }

    return($out);
} # dump



sub btrace
{
    my ($self) = @_;

    my $levels = 1;

    for (;;)
    {
	($package, $filename, $line) = caller($levels++);
	last unless ($line);

	print STDERR "called from $filename line $line (package $package)\n";
    }
}

# package dbrecs
# -------------------------------------------------------------------

1;
